package testing.visits_tracker;

import android.content.Context;
import android.telephony.TelephonyManager;
import android.util.Log;

import java.util.ArrayList;

/*
Visit class

Proces de gps data to extract visits data

 */

public class Visit {

    private DataWork dataWork;
    private int user_id;
    private String id;

    public Visit(){
        dataWork = new DataWork("rawgps.txt");
        id = "0";
        user_id = 1017;

    }

    /*
    Load and process the gps data saved in internal memory.

    Create a new visits
     */
    public void newVisit(Context c){

        TelephonyManager tm = (TelephonyManager) c.getSystemService(c.TELEPHONY_SERVICE);
        id = tm.getDeviceId();

        String saved, visits;
        visits = "id,latitude,longitude,horizontalAccuracy,arrivalDate,departureDate,receivedDate,user_id,receivedDate_exit\n";
        saved = dataWork.recuperar(c);
        if(saved==null){
            Log.i("Visit","NULL");
        }else {
            String visit;
            String[] data = saved.split("\n");
            String[] tracked, first, last;
            first = null;
            last = data[0].split(",");
            for (int i = 0; i < data.length; i = i + 1) {
                Log.i("Visit",String.valueOf(id));
                tracked = data[i].split(",");
                if (first == null) {
                    first = data[i].split(",");
                    last = data[i].split(",");
                } else {
                    if (near(first, tracked)) {
                        last = data[i].split(",");
                    } else {
                        visit = newVisit(first, last);
                        visits = visits + visit + "\n";
                        first = null;
                    }
                }
            }

        }

        dataWork.saveVisits(visits);
    }

    /*
    Check if two places are nearby
     */
    public boolean near(String[] first, String[] tracked){
        return(distFrom(Float.parseFloat(first[2]),Float.parseFloat(first[3]),Float.parseFloat(tracked[2]),
                Float.parseFloat(tracked[3])) < 50);
    }

    /*
    Check the distance between two places
     */
    public static float distFrom(float lat1, float lng1, float lat2, float lng2) {
        double earthRadius = 6371000; //meters
        double dLat = Math.toRadians(lat2-lat1);
        double dLng = Math.toRadians(lng2-lng1);
        double a = Math.sin(dLat/2) * Math.sin(dLat/2) +
                Math.cos(Math.toRadians(lat1)) * Math.cos(Math.toRadians(lat2)) *
                        Math.sin(dLng/2) * Math.sin(dLng/2);
        double c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1-a));
        return (float) (earthRadius * c);
    }

    /*
    Organizes the information of a new visit.
     */
    public String newVisit(String[] first, String[] last){
        String time = hourVisit(first[0], last[0]);
        this.id = this.id+1;
        String visit = String.valueOf(this.id) + "," //visit id
                + first[2] + "," //latitude
                + first[3] + "," //longitude
                + first[1] + "," //accuracy
                + first[0] + "," //arrival Date
                + last[0] + ","  //departure Date
                + last[0] + ","  //received Date
                + String.valueOf(user_id) + "," //user id
                + "0"; //receiveddate_exit
        return visit;
    }

    /*
    Calculate the time of a visit
     */
    public String hourVisit(String first, String last){
        String[] f = first.split(" ");
        String[] l = last.split(" ");
        String[] f_time = f[1].split(":");
        String[] l_time = l[1].split(":");
        float f_sec = (Float.parseFloat(f_time[0]) * 3600 )+ (Float.parseFloat(f_time[1])*60)+(Float.parseFloat(f_time[2]));
        float l_sec = (Float.parseFloat(l_time[0]) * 3600 )+ (Float.parseFloat(l_time[1])*60)+(Float.parseFloat(l_time[2]));
        float total = l_sec - f_sec;
        return String.valueOf(total%60);
    }
}
