'''
test.py

File for testing prediction algorithm.

Load and process data.
Show clustering data of every user.
Save results.

'''

from visits_tracker.util import resetDataBase
from visits_tracker.import_data import addData, updatePlaceType
from visits_tracker.plot import plotUsersVisits
from visits_tracker.classifier import sorter
from visits_tracker.export_data import showResults


def updateData():
	'''
	Update data of mysql database

	'''

	updatePlaceType()


def loadData():
	'''
	Load data from csv file

	'''

	path = "path csv file with visits data"
	addData(csv_file = path)


def init():
	'''
	Complet prediction process

	'''

	#Reset data base
	resetDataBase()

	#Load data to mysql: visits and visitfeatures
	loadData()

	#Clustering and Update mysql data
	updateData()

	#Show clustering
	plotUsersVisits()

	#Classification and results
	results = sorter()

	#Show results
	showResults(results)


init()