'''
clustering.py

Group visits with agglomerative clustering.
Group visits with near distance.

'''

from .models import VisitFeatures
from .util import compute_vincenty_distance
from sklearn.cluster import AgglomerativeClustering


def aglomerativeClust(VisitFeatures):
	'''
	Group near visits.

	Find the two most frequented places

	'''

	X = []
	cl = len(VisitFeatures)/10
	for vf in VisitFeatures:
		X.append([vf.visit.latitude, 
				vf.visit.longitude])

	model = AgglomerativeClustering(linkage = 'average', n_clusters = cl, connectivity = None, compute_full_tree = True)
	model = model.fit(X)

	labels = model.labels_

	for l in range(len(VisitFeatures)):
		VisitFeatures[l].placeType = str(labels[l])

	clusters = [[] for o in range(max(labels)+1)]

	for vf in VisitFeatures:
		clusters[int(vf.placeType)].append(vf)

	maxDist = [0. for o in range(max(labels)+1)]

	for m in range(len(clusters)):
		for vf in clusters[m]:
			for pv2 in clusters[m]: 
				dist = compute_vincenty_distance(vf.visit, pv2.visit)
				if(dist > maxDist[m]):
					maxDist[m] = dist

	maxDistance = 0
	while(maxDistance < 50):
		cl -= 1
		previous_labels = labels

		model = AgglomerativeClustering(linkage = 'average', n_clusters = cl, connectivity = None, compute_full_tree = True)
		model = model.fit(X)

		labels = model.labels_

		for j in range(len(VisitFeatures)):
			VisitFeatures[j].placeType = str(labels[j])

		clusters = [[] for o in range(max(labels)+1)]

		for vf in VisitFeatures:
			clusters[int(vf.placeType)].append(vf)
		maxDistance = 0
		aux = False
		for m in range(len(clusters)):
			if(aux):
				break
			for vf in clusters[m]:
				if(aux):
					break
				for pv2 in clusters[m]:
					dist = compute_vincenty_distance(vf.visit, pv2.visit)
        			if(dist > maxDistance):
        				maxDistance = dist
        				if(maxDistance > 50):
        					aux = True

        if(maxDistance > 50):
        	return previous_labels





'''

This is the K-Means iteravite code used during project development

Was changed to Agglomerative Clustering to hav ebetter results


class Aux(models.Model):
	latitude = models.DecimalField(decimal_places=14,max_digits=17)
	longitude = models.DecimalField(decimal_places=14,max_digits=17)



def iterativeKMeans():

	visitFeatures = VisitFeatures.objects.all()

	X = []
	for vf in visitFeatures:
		X.append([vf.visit.latitude, 
				vf.visit.longitude])

	k = 6
	kmeans = cluster.KMeans(algorithm='auto', n_clusters=k)
	kmeans.fit(X)

	labels = kmeans.labels_
	centroids = kmeans.cluster_centers_

	i = k

	clusters = separateClusters(X, labels, k)
	good, finishedC = cleanClusters(clusters, centroids)
	clusters = good
	doWhile = True
	while(((len(clusters) > 0) and True) or (doWhile)):
		doWhile = False

		c = clusters.pop(0)
		newCLusters, newCentroids = newKMeans(c,i)
		i += len(newCLusters)
		good, bad = cleanClusters(newCLusters, newCentroids)
		for nc in good:
			clusters.append(nc)
		for bc in bad:
			finishedC.append(bc)

	for c in clusters:
		finishedC.append(c)

	total = []
	i = 0
	for c in finishedC:
		print len(c)
		if(len(c) < 30):
			for a in c:
				a[2] = 0
		else:
			i+= 1
		for a in c:
			total.append(a)

	h = -1
	w = -2
	if i == 2:
		for t in total:
			if (t[2] != 0):
				if (h == -1):
					h = t[2]
				else:
					if(t[2] != h):
						w = t[2]

	for t in total:
		if(t[2] == h):
			t[2] = 1
		if(t[2] == w):
			t[2] = 2
				

	return total



def separateClusters(X, labels, k):

	clusters = [[] for i in range(k)]
	i = 0
	for coord in X:
		clusters[labels[i]].append([coord[0],coord[1],labels[i]])
		i += 1

	return clusters


def cleanClusters(clusters, centroids):

	good, bad = [], []

	i = 0
	for c in clusters:
		if((len(c) > 30) and (near(c, centroids[i]))):
			good.append(c)
		else:
			bad.append(c)
		i+=1

	return good, bad


def near(c, centroid):
	print "Near"

	visit_cent = Aux(latitude = centroid[0], longitude = centroid[1])

	for clust in c:
		visit_clust = Aux(latitude = clust[0], longitude = clust[1])
		if(compute_vincenty_distance(visit_cent, visit_clust) > 20):
			return True
	return False



def newKMeans(cl, i):
	print "New K-Means"

	X = []
	for c in cl:
		X.append([c[0],c[1]])

	k = random.randint(2,6)
	kmeans = cluster.KMeans(algorithm='auto', n_clusters=k)
	kmeans.fit(X)

	labels = kmeans.labels_
	centroids = kmeans.cluster_centers_

	clusters = separateClusters(X, labels, k)


	for c in clusters:
		for a in c:
			a[2] += i

	return clusters, centroids


'''
