'''
export_data.py

Show results in command line.
Save results in text file.

'''

def showResults(resultsAllUsers):
    '''
    Show results of all users

    '''

    results = ""

    for user_results in resultsAllUsers:
        user          = user_results['user']
        training      = user_results['training']
        correct       = user_results['correct']
        total         = user_results['total']
        truePositive  = user_results['truePositive']
        falsePosivite = user_results['falsePositive']
        falseNegative = user_results['falseNegative']
        totalFail     = user_results['totalFail']
        precision     = user_results['precision']
        recall        = user_results['recall']

        results += "\nResults for user: " + str(user) + "\n"
        results += "Number of predicted values: " + str(total) + "\n"
        results += "Number of values to train the decision tree: " + str(training) + "\n"
        results += "Precision value for house results: %.2f" % round(precision[0]*100,2) + "%\n"
        results += "Recall value for house results: %.2f" % round(recall[0]*100,2) + "%\n"
        results += "Precision value for work results: %.2f" % round(precision[1]*100,2) + "%\n"
        results += "Recall value for work results: %.2f" % round(recall[1]*100,2) + "%\n"
        results += "Number of no predicted values: " + str(totalFail) + "\n\n"

    #Show results in command line
    print results

    #Save rasults in a text file
    file = open("ResultsAllUsers.txt","w")
    file.write(results)
    file.close()
