'''
models.py

Implementation of the database

'''

from django.db import models


class Visit(models.Model):
    '''
    Visit data

    '''

    user_id = models.BigIntegerField(default = 0)
    latitude = models.DecimalField(decimal_places=13,max_digits=17)
    longitude = models.DecimalField(decimal_places=14,max_digits=17)
    horizontalAccuracy = models.DecimalField(decimal_places=14,max_digits=17) #in metres
    arrivalDate = models.BigIntegerField()
    departureDate = models.BigIntegerField()
    
    def __unicode__(self):
        return "<" + str(self.user_id) + "," + str(self.latitude) + "," + str(self.longitude) + "," + str(self.arrivalDate) + "," + str(self.departureDate) + "," + str(self.horizontalAccuracy) + ">"

class VisitFeatures(models.Model):
    '''
    VisitFeatures data

    '''

    visit = models.OneToOneField(Visit, blank = False, null = True)
    placeType = models.CharField(blank = True, max_length=12, default = "")
    timeSlot = models.IntegerField(blank = True, default = -1)
    workingDay = models.NullBooleanField(blank = True, default = None)
    day_of_week = models.IntegerField(blank = True, default = -1)
    hour_of_day = models.IntegerField(blank = True, default = -1)
    half_of_day = models.IntegerField(blank = True, default = -1)
    third_of_day = models.IntegerField(blank = True, default = -1)
    month = models.IntegerField(blank = True, default = -1)
    week_of_month = models.IntegerField(blank = True, default = -1)
    half_of_month = models.IntegerField(blank = True, default = -1)
    duration = models.IntegerField(blank = True, default = 0)
    accuracy = models.DecimalField(decimal_places=9,max_digits=17, default=0)
    distanceToHome = models.DecimalField(decimal_places=9,max_digits=17, default= 0)
    previous_placeType = models.CharField(blank = True, max_length=12, default = "")
    previous_timeSlot = models.IntegerField(blank = True, default = -1)
    averageTimePlaceVisit = models.DecimalField(decimal_places=9,max_digits=17, default= 0)
    minTimePlaceVisit = models.DecimalField(decimal_places=9,max_digits=17, default= 0)
    maxTimePlaceVisit = models.DecimalField(decimal_places=9,max_digits=17, default= 0)

    def __unicode__(self):
        return ("<" + str(self.visit) + "," + self.placeType + "," + str(self.timeSlot) + "," + str(self.workingDay) 
        + "," + str(self.day_of_week) + "," + str(self.hour_of_day) + "," + str(self.half_of_day)
        + "," + str(self.third_of_day) + "," + str(self.month) + "," + str(self.week_of_month)
        + "," + str(self.half_of_month) + "," + str(self.duration) + ">")
