'''
plot.py 

Display the graph of the clustered data of each user

'''

from .models import VisitFeatures
from matplotlib import pyplot


def plotUsersVisits():
    '''
    Plot data of all users saved in MySQL database

    '''

    #Load data of all users
    visitFeatures = VisitFeatures.objects.all()

    #List users
    users = []
    for vf in visitFeatures:
        user = vf.visit.user_id
        if(not user in users):
            users.append(user)

    #Plot data of every user
    for user in users:
        visits = [vf for vf in visitFeatures if vf.visit.user_id == float(user)]
        X = []
        Y = []
        labels = []

        for vf in visitFeatures:
            X.append(vf.visit.longitude)
            Y.append(vf.visit.latitude)
            labels.append(str(vf.placeType))

        pyplot.scatter(X,Y,c = labels)
        pyplot.show()